//+------------------------------------------------------------------+
//|                               Hercs_Stoch_ARROW_Y.mq4            |
//+------------------------------------------------------------------+
#property copyright "AHGDP"
#property link      "Hercs_Stoch_ARROW_Y"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
#property indicator_color3 DodgerBlue
#property indicator_width3 2
#property indicator_color4 Magenta
#property indicator_width4 2
#property indicator_color5 Aqua//Lime
#property indicator_width5 1
#property indicator_color6 Yellow//Red
#property indicator_width6 1

#property indicator_maximum 105                     
#property indicator_minimum -5

extern int     K_Period              = 5 ;   
extern int     D_Period              = 3 ;  
extern int     Slowing               = 4 ; 
 
extern int     LineSize1             = 2 ;
extern int     LineSize2             = 2 ;
extern int     CountBars             = 600 ;
extern int     In_Window             = 1 ;
extern bool    STO_Script            = false ;
extern bool    NoName                = true ; 

extern string  wp_6                  = "== ALERTS ON ===";
extern bool    Use.Alert             = false ;
extern bool    Draw.Arrows           = True;
extern int     Shift.Arrow.back      = 0;

extern string  wp_7                  = "===  ARROWS =====";
extern int     DN.CODE               = 116;
extern color   ArrowDN.Color         = Yellow;

extern int     UP.CODE               = 116;
extern color   ArrowUP.Color         = Aqua;

extern int     ArrowSize             = 3;
extern int     ArrowDistance         = 1;

string         shortName_HSAY        = "HSAY" ;
int            MagicNumber           = 0 ;

int            iAlertCount           = 0;
datetime       alertTagHSAY;
string         signalHSAY;
string         lastsignalHSAY;

double sig1n[];
double sig1d[];
double sig2n[];
double sig2d[];
double upX[],dnX[];
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
  {
    IndicatorDigits(+0);
    IndicatorBuffers(6);
   SetIndexStyle (0,DRAW_LINE,STYLE_SOLID,LineSize1);
   SetIndexBuffer(0,sig1n);
   SetIndexStyle (1,DRAW_LINE,STYLE_SOLID,LineSize1);
   SetIndexBuffer(1,sig1d);
   SetIndexStyle (2,DRAW_LINE,STYLE_SOLID,LineSize2);
   SetIndexBuffer(2,sig2n);
   SetIndexStyle (3,DRAW_LINE,STYLE_SOLID,LineSize2);
   SetIndexBuffer(3,sig2d);

   SetIndexStyle (4,DRAW_ARROW,STYLE_SOLID,LineSize2);
   SetIndexArrow (4,159);
   SetIndexBuffer(4,upX);
   SetIndexStyle (5,DRAW_ARROW,STYLE_SOLID,LineSize2);
   SetIndexArrow (5,159);
   SetIndexBuffer(5,dnX);

//=========MagicNumber Generator + shortname========================= 
        MathSrand(TimeLocal() + TimeCurrent());
        int mn = MathRand();
        MathSrand(mn);
        mn = MathRand();   
        MagicNumber = mn;
        IndicatorShortName("HSAYan_M5"); 
//========================  SHORTNAME  ==============================================================         
           if  ( NoName == false  )
             {    string  Text = "(STO)";
                  Text=Text+"(";
                  Text=Text+""+DoubleToStr(K_Period,0);
                  Text=Text+","+DoubleToStr(D_Period,0);
                  Text=Text+","+DoubleToStr(Slowing,0);
                  Text=Text+")";
                  IndicatorShortName(Text); 
            }    
             
   SetIndexLabel (0,"["+DoubleToStr(K_Period ,0)+" , "+DoubleToStr(D_Period ,0)+" , "+DoubleToStr(Slowing ,0)+" ]");  
   SetIndexLabel (1,"["+DoubleToStr(K_Period ,0)+" , "+DoubleToStr(D_Period ,0)+" , "+DoubleToStr(Slowing ,0)+" ]");          
//========================================================================== 
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int deinit()
   { // for(int i=0;i<ObjectsTotal();i++)
    // {  ObjectsDeleteAll(0,OBJ_ARROW);
    // }
          Refresh();
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
  {   Refresh();
  
     int i,i2,counted_bars=IndicatorCounted();
     double rsi,maxrsi,minrsi,storsi,E3D,
     sig1,sig2,sk,ss,sk2;
     double cs;
     bool init=true;
   
   if(Bars<=cs) return(0);
   
//=============HORIZONTAL COLOR LINES ======================================================  
 
  double indlev1 , indlev2 , indlev3 , indlev4 , indlev5 ;
    switch(Period()) 
  { case 1:  case 5: case 15: case 30:  case 60: case 240: case 1440: case 10080: case 43200:
  
    indlev1 = 50 ; 
    indlev2 = 80 ; 
    indlev3 = 20 ; 
    indlev4 = 95 ; 
    indlev5 = 5 ;   
    break;
  }   
      drawLine_HSAY(indlev1,  "LnA_HSAY"+MagicNumber   ,  BurlyWood    ); 
      drawLine_HSAY(indlev2,  "LnB_HSAY"+MagicNumber   ,  C'204,122,72');
      drawLine_HSAY(indlev3,  "LnC_HSAY"+MagicNumber   ,  C'204,122,72');
      drawLine_HSAY(indlev4,  "LnD_HSAY"+MagicNumber   ,  Red);//C'204,122,72');
      drawLine_HSAY(indlev5,  "LnE_HSAY"+MagicNumber   ,  Red);//C'204,122,72');
   
//============================  STOCH ==============================================================   
   if(counted_bars<1)
      {
      for(i=1;i<=cs;i++) sig1n[Bars-i]=0.0;
      for(i=1;i<=cs;i++) sig2n[Bars-i]=0.0;
      for(i=1;i<=cs;i++) upX[Bars-i]  =0.0;
      for(i=1;i<=cs;i++) dnX[Bars-i]  =0.0;
      }
      
   i=Bars-cs-1;
   
   if (counted_bars>=cs) i=CountBars; 
   while (i>=0)
    {
      sig2n[i]=(iStochastic(NULL,0,K_Period,D_Period,Slowing,MODE_SMA,0,MODE_SIGNAL,i));
      sig1n[i]=(iStochastic(NULL,0,K_Period,D_Period,Slowing,MODE_SMA,0,MODE_MAIN,i));
      sig1=sig1n[i];
      sig2=sig2n[i];   

//=======================  DOT ON STOCH ====================================================  
     
      if (sig1n[i]>sig2n[i] && sig1n[i+1]<sig2n[i+1] )      upX[i]=sig2n[i]-10;
      if (sig1n[i]<sig2n[i] && sig1n[i+1]>sig2n[i+1] )      dnX[i]=sig2n[i]+10;
  
//=======================  COLOR CODE STOCH ====================================================   
   {   sig1d[i] = EMPTY_VALUE;
      
      if   ( sig1n[i + 1] < sig1n[i] )  {sig1d[i + 1] = sig1d[i + 1];
                                               sig1d[i] = sig1d[i];
           }
     else 
          {  if  (sig1n[i + 1] > sig1n[i])
                 {   if (sig1d[i + 1] == EMPTY_VALUE) sig1d[i + 1] = sig1n[i + 1];
                                                         sig1d[i] = sig1n[i];
   }      }      }     
   
//=============  COLOR CODE SIGNAL LINE ===============================================================  
   {    sig2d[i] = EMPTY_VALUE;
      
      if   ( sig2n[i + 1] < sig2n[i] )  {sig2d[i + 1] = sig2d[i + 1];
                                               sig2d[i] = sig2d[i];
           }
     else 
          {  if  (sig2n[i + 1] > sig2n[i])
                 {    if (sig2d[i + 1] == EMPTY_VALUE) sig2d[i + 1] = sig2n[i + 1];
                                                         sig2d[i] = sig2n[i];
   }      }      }            
//============================================================================================
      if (i<=2) 
    {      if (Use.Alert)
     {             if (sig1n[i]<sig2n[i] && sig1n[i+1]>sig2n[i+1] )   // close of prev candle [i+2]  [i+1] 
            {          signalHSAY="Short";                                        // when change dir      [i+1]  [i+0]
                  if ((lastsignalHSAY != signalHSAY) && (alertTagHSAY!=Time[0]) && (iAlertCount==0))
          
                  {   PlaySound("enter now.wav");//("alert2.wav")<<<<<<<<< NB !! ENTER NOW
                      iAlertCount++;
                  }
                      alertTagHSAY = Time[0];
                      lastsignalHSAY=signalHSAY;
           }
              else 
       {          if (sig1n[i]>sig2n[i] && sig1n[i+1]<sig2n[i+1] )  // close of prev candle [i+2]  [i+1]
           {           signalHSAY="Long";                                       // when change dir      [i+1]  [i+0]
                  if ((lastsignalHSAY != signalHSAY) && (alertTagHSAY!=Time[0]) && (iAlertCount==0))
           
                  {    PlaySound("enter now.wav");//<<<< NB !!
                       iAlertCount++;
                  }
                      alertTagHSAY = Time[0];
                      lastsignalHSAY=signalHSAY;
           }
               else
                 {  signalHSAY="None";
                    iAlertCount=0;
                 }
   }}  }
//==============================================================================================           

   if (Draw.Arrows==True)
      {  
          {  if (sig1n[i]<sig2n[i] && sig1n[i+1]>sig2n[i+1] )    // close of prev candle [i+2]  [i+1]       
              {                                                  // when change dir      [i+1]  [i+0]
                ObjectCreate ("HSAY_Short"+TimeToStr(Time[i+Shift.Arrow.back]),OBJ_ARROW,0,Time[i+Shift.Arrow.back],High[i+Shift.Arrow.back]+(ArrowDistance+2)*Point);
                ObjectSet    ("HSAY_Short"+TimeToStr(Time[i+Shift.Arrow.back]),OBJPROP_ARROWCODE,DN.CODE);
                ObjectSet    ("HSAY_Short"+TimeToStr(Time[i+Shift.Arrow.back]),OBJPROP_WIDTH,ArrowSize);
                ObjectSet    ("HSAY_Short"+TimeToStr(Time[i+Shift.Arrow.back]),OBJPROP_COLOR,ArrowDN.Color);
         }    }

        {  if (sig1n[i]>sig2n[i] && sig1n[i+1]<sig2n[i+1] )  // close of prev candle [i+2]  [i+1]   
              {                                              // when change dir      [i+1]  [i+0]
                ObjectCreate ("HSAY_Long"+TimeToStr(Time[i+Shift.Arrow.back]),OBJ_ARROW,0,Time[i+Shift.Arrow.back],Low[i+Shift.Arrow.back]-ArrowDistance*Point);
                ObjectSet    ("HSAY_Long"+TimeToStr(Time[i+Shift.Arrow.back]),OBJPROP_ARROWCODE,UP.CODE);
                ObjectSet    ("HSAY_Long"+TimeToStr(Time[i+Shift.Arrow.back]),OBJPROP_WIDTH,ArrowSize);
                ObjectSet    ("HSAY_Long"+TimeToStr(Time[i+Shift.Arrow.back]),OBJPROP_COLOR,ArrowUP.Color);
       }      }       
    }      
//======================= LABEL =================================================        
      i--;    
  { {
       ObjectDelete("Line1");
       Line1( "Line1", 0, 0, 0);
       if  ( STO_Script )  
       ObjectSetText("Line1",DoubleToStr(sig1,2),12,"Arial Bold",White);
     }
       ObjectDelete("Line2");
       Line2( "Line2", 0, 0, 0);
        if  ( STO_Script )  
       ObjectSetText("Line2",DoubleToStr(sig2,2),12,"Arial Bold",White);
   } } }
   
  int Line1( string Text, int xOffset, int yOffset,int iCorner) //LINE
   {  ObjectCreate(Text,OBJ_LABEL         , In_Window, 0, 0 );
      ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
      ObjectSet   (Text,OBJPROP_XDISTANCE , 800 );//800
      ObjectSet   (Text,OBJPROP_YDISTANCE , 10 );
      ObjectSet   (Text,OBJPROP_BACK      , True );
   } 
  int Line2( string Text, int xOffset, int yOffset,int iCorner) 
   {  ObjectCreate(Text,OBJ_LABEL         , In_Window , 0, 0 );
      ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
      ObjectSet   (Text,OBJPROP_XDISTANCE , 800 );//800
      ObjectSet   (Text,OBJPROP_YDISTANCE , 30 );
      ObjectSet   (Text,OBJPROP_BACK      , True );
   } 
//============================================================================        
   return(0);
//================HORIZONTAL COLOR LINES=====================================
void drawLine_HSAY(double lvl_HSAY,string name_HSAY, color Col_HSAY )
{int indicatorWindow_HSAY = WindowFind(shortName_HSAY);
   if(indicatorWindow_HSAY < 0)
       return;
       
   ObjectDelete(name_HSAY);
   ObjectCreate(name_HSAY, OBJ_HLINE,indicatorWindow_HSAY, Time[0], lvl_HSAY,Time[0],lvl_HSAY);
   ObjectSet   (name_HSAY ,OBJPROP_STYLE, STYLE_DOT);
   ObjectSet   (name_HSAY ,OBJPROP_COLOR, Col_HSAY);   
   ObjectSet   (name_HSAY , OBJPROP_BACK, true);      
   ObjectSet   (name_HSAY ,OBJPROP_WIDTH, 1);
  }  
//====================================================================
void Refresh() 
   {              
      ObjectDelete("LnA_HSAY");   
      ObjectDelete("LnB_HSAY");   
      ObjectDelete("LnC_HSAY"); 
      ObjectDelete("LnD_HSAY"); 
      ObjectDelete("LnE_HSAY"); 
      ObjectDelete("HSAY_Long");   
      ObjectDelete("HSAY_Short");  
      ObjectsDeleteAll(0,OBJ_ARROW); 
   }
//====================================================================   